From 30874748a9c40baf3473dd172c05ae0f7fb46cdf Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Thu, 14 Feb 2019 20:17:34 +0100
Subject: [PATCH 2/2] add archivo narrow font (#29192)

---
 README                                        |   8 ++++++++
 .../archivonarrow-bold-webfont.woff           | Bin 0 -> 25848 bytes
 .../archivonarrow-bold-webfont.woff2          | Bin 0 -> 19568 bytes
 .../archivonarrow-bolditalic-webfont.ttf      | Bin 0 -> 52116 bytes
 .../archivonarrow-bolditalic-webfont.woff     | Bin 0 -> 28328 bytes
 .../archivonarrow-bolditalic-webfont.woff2    | Bin 0 -> 22136 bytes
 .../archivonarrow-regular-italic-webfont.ttf  | Bin 0 -> 51940 bytes
 .../archivonarrow-regular-italic-webfont.woff | Bin 0 -> 27920 bytes
 ...archivonarrow-regular-italic-webfont.woff2 | Bin 0 -> 21820 bytes
 .../archivonarrow-regular-webfont.woff        | Bin 0 -> 25740 bytes
 .../archivonarrow-regular-webfont.woff2       | Bin 0 -> 19480 bytes
 static/includes/_font-archivo-narrow.scss     |  18 ++++++++++++++++++
 12 files changed, 26 insertions(+)
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-bold-webfont.woff
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-bold-webfont.woff2
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.ttf
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.woff
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.woff2
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.ttf
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.woff
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.woff2
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-regular-webfont.woff
 create mode 100644 static/fonts/ArchivoNarrow/archivonarrow-regular-webfont.woff2
 create mode 100644 static/includes/_font-archivo-narrow.scss

diff --git a/README b/README
index 177ce1f0..d7e6ce28 100644
--- a/README
+++ b/README
@@ -126,6 +126,14 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/khand
 
+* Archivo Narrow
+  # Copyright (c) 2012, Omnibus-Type (omnibus.type@gmail.com),
+  # with Reserved Font Name "Archivo";
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://www.fontsquirrel.com/license/archivo-narrow
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-bold-webfont.woff b/static/fonts/ArchivoNarrow/archivonarrow-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..c2b674a47993ed2a5dd4c3a7365153239ff80ba7
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-bold-webfont.woff2 b/static/fonts/ArchivoNarrow/archivonarrow-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..64f83e56dfba9e4a9c64900b36e85ee36e7bbf80
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.ttf b/static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.ttf
new file mode 100644
index 0000000000000000000000000000000000000000..c4ea0a5b0d862c24251027f388de677c44b346a1
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.woff b/static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..71fb36e286c7c8d1755744080a23e5af63f83787
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.woff2 b/static/fonts/ArchivoNarrow/archivonarrow-bolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..43bb87d275cb751616402aba516b6a50df8894ad
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.ttf b/static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.ttf
new file mode 100644
index 0000000000000000000000000000000000000000..3b9adea97a09618cb47593800e4e0eebf983dd96
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.woff b/static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..26c97d08dc546b001ecf816e9644445e357f60ca
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.woff2 b/static/fonts/ArchivoNarrow/archivonarrow-regular-italic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..948844b082cb482ec1270ef0617ad68d32625627
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-regular-webfont.woff b/static/fonts/ArchivoNarrow/archivonarrow-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..2168d50a84a57a76d7c14cdec02d2621d23cc5ef
GIT binary patch
diff --git a/static/fonts/ArchivoNarrow/archivonarrow-regular-webfont.woff2 b/static/fonts/ArchivoNarrow/archivonarrow-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..34def929de15a09edcdd56523b26626340612581
GIT binary patch
diff --git a/static/includes/_font-archivo-narrow.scss b/static/includes/_font-archivo-narrow.scss
new file mode 100644
index 00000000..2b934e65
--- /dev/null
+++ b/static/includes/_font-archivo-narrow.scss
@@ -0,0 +1,18 @@
+@mixin archivonarrow-font($type, $weight, $style) {
+	@font-face {
+		font-family: 'Archivo Narrow';
+		src: url('../fonts/ArchivoNarrow/archivonarrow-#{$type}-webfont.woff2') format('woff2'),
+		     url('../fonts/ArchivoNarrow/archivonarrow-#{$type}-webfont.woff') format('woff'),
+		     url('../fonts/ArchivoNarrow/archivonarrow-#{$type}-webfont.ttf') format('truetype');
+		font-weight: $weight;
+		font-style: $style;
+	}
+}
+
+@mixin archivonarrow-font-pair($type, $weight) {
+	@include archivonarrow-font($type, $weight, normal);
+	@include archivonarrow-font('#{$type}italic', $weight, italic);
+}
+
+@include archivonarrow-font-pair('regular', 400);
+@include archivonarrow-font-pair('bold', 700);
-- 
2.20.1