From 2855a38ba88179a31ff26887326116a4150e4de0 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Thu, 14 Feb 2019 20:09:30 +0100
Subject: [PATCH 1/2] add khand font (#29192)

---
 README                                          |   7 +++++++
 static/fonts/Khand/khand-bold-webfont.ttf       | Bin 0 -> 42236 bytes
 static/fonts/Khand/khand-bold-webfont.woff      | Bin 0 -> 23064 bytes
 static/fonts/Khand/khand-bold-webfont.woff2     | Bin 0 -> 17608 bytes
 static/fonts/Khand/khand-light-webfont.woff     | Bin 0 -> 22216 bytes
 static/fonts/Khand/khand-light-webfont.woff2    | Bin 0 -> 16544 bytes
 static/fonts/Khand/khand-medium-webfont.ttf     | Bin 0 -> 42256 bytes
 static/fonts/Khand/khand-medium-webfont.woff    | Bin 0 -> 23180 bytes
 static/fonts/Khand/khand-medium-webfont.woff2   | Bin 0 -> 17776 bytes
 static/fonts/Khand/khand-regular-webfont.woff   | Bin 0 -> 23124 bytes
 static/fonts/Khand/khand-regular-webfont.woff2  | Bin 0 -> 17340 bytes
 static/fonts/Khand/khand-semibold-webfont.woff  | Bin 0 -> 23756 bytes
 static/fonts/Khand/khand-semibold-webfont.woff2 | Bin 0 -> 17852 bytes
 static/includes/_font-khand.scss                |  15 +++++++++++++++
 14 files changed, 22 insertions(+)
 create mode 100644 static/fonts/Khand/khand-bold-webfont.ttf
 create mode 100644 static/fonts/Khand/khand-bold-webfont.woff
 create mode 100644 static/fonts/Khand/khand-bold-webfont.woff2
 create mode 100644 static/fonts/Khand/khand-light-webfont.woff
 create mode 100644 static/fonts/Khand/khand-light-webfont.woff2
 create mode 100644 static/fonts/Khand/khand-medium-webfont.ttf
 create mode 100644 static/fonts/Khand/khand-medium-webfont.woff
 create mode 100644 static/fonts/Khand/khand-medium-webfont.woff2
 create mode 100644 static/fonts/Khand/khand-regular-webfont.woff
 create mode 100644 static/fonts/Khand/khand-regular-webfont.woff2
 create mode 100644 static/fonts/Khand/khand-semibold-webfont.woff
 create mode 100644 static/fonts/Khand/khand-semibold-webfont.woff2
 create mode 100644 static/includes/_font-khand.scss

diff --git a/README b/README
index 8f755e82..177ce1f0 100644
--- a/README
+++ b/README
@@ -119,6 +119,13 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/montserrat
 
+* Khand font
+  # Copyright (c) 2014, Indian Type Foundry (info@indiantypefoundry.com).
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://www.fontsquirrel.com/license/khand
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/Khand/khand-bold-webfont.ttf b/static/fonts/Khand/khand-bold-webfont.ttf
new file mode 100644
index 0000000000000000000000000000000000000000..d73a03395fb0b4b4cfc17434a9b2952ae51e9c0c
GIT binary patch
diff --git a/static/fonts/Khand/khand-bold-webfont.woff b/static/fonts/Khand/khand-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..db0aa667b92eb6efb0c6c96ee252bc4bc5ddc5ba
GIT binary patch
diff --git a/static/fonts/Khand/khand-bold-webfont.woff2 b/static/fonts/Khand/khand-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a935559527b447a2ca6718ff7fe9988a1210986f
GIT binary patch
diff --git a/static/fonts/Khand/khand-light-webfont.woff b/static/fonts/Khand/khand-light-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..26386c229658eb1c510536a75493535dd6ac0905
GIT binary patch
diff --git a/static/fonts/Khand/khand-light-webfont.woff2 b/static/fonts/Khand/khand-light-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c62b77d25f73f2532e06d8def1df06b4872533f1
GIT binary patch
diff --git a/static/fonts/Khand/khand-medium-webfont.ttf b/static/fonts/Khand/khand-medium-webfont.ttf
new file mode 100644
index 0000000000000000000000000000000000000000..5d915d691334e4ec71bcb05f59043bf095643835
GIT binary patch
diff --git a/static/fonts/Khand/khand-medium-webfont.woff b/static/fonts/Khand/khand-medium-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..5460f8fa9dae4efd7fc3abb514c13ff9be84ca7d
GIT binary patch
diff --git a/static/fonts/Khand/khand-medium-webfont.woff2 b/static/fonts/Khand/khand-medium-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..37bd934c652c34e41d9bd9cb297dd6caa9c82ff0
GIT binary patch
diff --git a/static/fonts/Khand/khand-regular-webfont.woff b/static/fonts/Khand/khand-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..2324274874cd92f10cea5cb7f6b5a8bf45c622b6
GIT binary patch
diff --git a/static/fonts/Khand/khand-regular-webfont.woff2 b/static/fonts/Khand/khand-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..1429473ae4daad948c622d3f0fd04da61bd52030
GIT binary patch
diff --git a/static/fonts/Khand/khand-semibold-webfont.woff b/static/fonts/Khand/khand-semibold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..47d61a842f2cdfbea0596a208bd0d6f63eedadb1
GIT binary patch
diff --git a/static/fonts/Khand/khand-semibold-webfont.woff2 b/static/fonts/Khand/khand-semibold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..e9632a1c89d16d76c5e71c1489e68263fcd614c5
GIT binary patch
diff --git a/static/includes/_font-khand.scss b/static/includes/_font-khand.scss
new file mode 100644
index 00000000..76f2b996
--- /dev/null
+++ b/static/includes/_font-khand.scss
@@ -0,0 +1,15 @@
+@mixin khand-font($type, $weight) {
+	@font-face {
+		font-family: 'Khand';
+		src: url('../fonts/Khand/khand-#{$type}-webfont.woff2') format('woff2'),
+		     url('../fonts/Khand/khand-#{$type}-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: normal;
+	}
+}
+
+@include khand-font('light', 300);
+@include khand-font('regular', 400);
+@include khand-font('medium', 500);
+@include khand-font('semibold', 600);
+@include khand-font('bold', 700);
-- 
2.20.1